unit uHlavni;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient,
  IdHTTP, StdCtrls, Menus, IniFiles, xmldom, XMLIntf, msxmldom, XMLDoc;

type
  TfrmHlavni = class(TForm)
    HTTP: TIdHTTP;
    mnuHlavni: TMainMenu;
    mitProgram: TMenuItem;
    mitKonec: TMenuItem;
    mitSpojeni: TMenuItem;
    mitVyhledat: TMenuItem;
    mitNastaveniPripojeni: TMenuItem;
    mitN1: TMenuItem;
    XMLparser: TXMLDocument;
    mitSeznamStanic: TMenuItem;
    mitNapoveda: TMenuItem;
    mitOkna: TMenuItem;
    N1: TMenuItem;
    Dladice1: TMenuItem;
    Kaskda1: TMenuItem;
    Vyrovnatikony1: TMenuItem;
    procedure mitKonecClick(Sender: TObject);
    procedure mitNastaveniPripojeniClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure mitSeznamStanicClick(Sender: TObject);
    procedure mitVyhledatClick(Sender: TObject);
    procedure mitNapovedaClick(Sender: TObject);
    procedure Dladice1Click(Sender: TObject);
    procedure Kaskda1Click(Sender: TObject);
    procedure Vyrovnatikony1Click(Sender: TObject);
  private
    { Private declarations }
  public
    pripServer:string;
    pripPort:integer;
    seznamStanic:TStringList;
    procedure NactiNastaveni;
    procedure UlozNastaveni;
    function NactiSeznamStanic:boolean;

  end;

var
  frmHlavni: TfrmHlavni;

function MessageBox(h:HWND;text:string;fmt:array of const;flags:integer):integer;overload;
function MessageBox(h:HWND;text:string;flags:integer):integer;overload;

implementation

uses uPripojeni, uVyhledavani, uHelp;

{$R *.dfm}

//******************************************************************************
//******************************************************************************
function MessageBox(h:HWND;text:string;fmt:array of const;flags:integer):integer;
begin
  result:=
    windows.messagebox(h,pchar(format(text,fmt)),'Jzdn dy',flags);
end;

//******************************************************************************
//******************************************************************************
function MessageBox(h:HWND;text:string;flags:integer):integer;
begin
  result:=
    windows.messagebox(h,pchar(text),'Jzdn dy',flags);
end;


//******************************************************************************
//******************************************************************************
procedure TfrmHlavni.mitKonecClick(Sender: TObject);
begin
  Close;
end;

//******************************************************************************
//******************************************************************************
procedure TfrmHlavni.NactiNastaveni;
var
  ini:TMemIniFile;
begin
  ini:=TmemIniFile.Create(extractFilePath(paramstr(0))+'nastaveni.ini');
  pripServer:=ini.ReadString('pripojeni','server','localhost');
  pripPort:=ini.ReadInteger('pripojeni','port',80);
  ini.free;
end;

//******************************************************************************
//******************************************************************************
procedure TfrmHlavni.UlozNastaveni;
var
  ini:TMemIniFile;
begin
  ini:=TmemIniFile.Create(extractFilePath(paramstr(0))+'nastaveni.ini');
  ini.WriteString('pripojeni','server',pripServer);
  ini.WriteInteger('pripojeni','port',pripPort);
  ini.UpdateFile;
  ini.free;
end;

//******************************************************************************
//******************************************************************************
procedure TfrmHlavni.mitNastaveniPripojeniClick(Sender: TObject);
begin
  frmPripojeni.NastavPripojeni;
end;

//******************************************************************************
//******************************************************************************
procedure TfrmHlavni.FormCreate(Sender: TObject);
begin
  seznamStanic:=nil;
  NactiNastaveni;
end;

//******************************************************************************
//******************************************************************************
procedure TfrmHlavni.FormDestroy(Sender: TObject);
begin
  UlozNastaveni;
end;

//******************************************************************************
//******************************************************************************
function TfrmHlavni.NactiSeznamStanic:boolean;
var
  list:IXMLnodeList;
  i:integer;
begin
  result:=true;
  screen.Cursor:=crHourGlass;
  try
    if seznamStanic=nil then
      seznamStanic:=TStringList.Create;
    seznamStanic.Clear;

    XMLparser.XML.Text:=HTTP.Get('http://'+pripServer+'/SeznamStanic');
    XMLparser.Active:=true;
    if XMLparser.IsEmptyDoc then
      raise EAbort.Create('Dokument je przdn');
    list:=XMLparser.ChildNodes.FindNode('SeznamStanic').ChildNodes;
    for i:=0 to list.Count-1 do begin
      seznamStanic.Add(list.Get(i).NodeValue);
    end;
  except
    on e:exception do begin
      seznamStanic.Free;      
      messageBox(handle,'Chyba pi natn seznamu stanic: '#13#10'%s',[e.message],MB_ICONERROR);
      result:=false;
    end;
  end;
  screen.Cursor:=crDefault;
end;

//******************************************************************************
//******************************************************************************
procedure TfrmHlavni.mitSeznamStanicClick(Sender: TObject);
begin
  NactiSeznamStanic;
end;

//******************************************************************************
//******************************************************************************
procedure TfrmHlavni.mitVyhledatClick(Sender: TObject);
begin
  if seznamStanic=nil then begin
    if not NactiSeznamStanic then begin
      exit;
    end;
  end;

  frmVyhledavani.Ukaz;
end;

//******************************************************************************
//******************************************************************************
procedure TfrmHlavni.mitNapovedaClick(Sender: TObject);
begin
  frmHelp:=TfrmHelp.Create(Application);
end;

//******************************************************************************
//******************************************************************************
procedure TfrmHlavni.Dladice1Click(Sender: TObject);
begin
  Tile;
end;

//******************************************************************************
//******************************************************************************
procedure TfrmHlavni.Kaskda1Click(Sender: TObject);
begin
  Cascade;
end;

//******************************************************************************
//******************************************************************************
procedure TfrmHlavni.Vyrovnatikony1Click(Sender: TObject);
begin
  ArrangeIcons;
end;

end.
