unit uVysledky;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, uTypy, xmldom, XMLIntf, StdCtrls, IdBaseComponent, IdComponent,
  IdTCPConnection, IdTCPClient, IdHTTP, msxmldom, XMLDoc, ExtCtrls;

type
  TfrmVysledky = class(TForm)
    XMLparser: TXMLDocument;
    HTTP: TIdHTTP;
    pnlVrch: TPanel;
    lblOdkud1: TLabel;
    lblKam1: TLabel;
    lblPres1: TLabel;
    lblOdkud2: TLabel;
    lblKam2: TLabel;
    lblPres2: TLabel;
    lblOdjezd1: TLabel;
    lblOdjezd2: TLabel;
    lblPrestupy2: TLabel;
    lblPrestupy1: TLabel;
    lblSpojeni1: TLabel;
    lblSpojeni2: TLabel;
    cbxSpoj: TComboBox;
    lblZobrazSpoj: TLabel;
    memSpojeni: TMemo;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure cbxSpojChange(Sender: TObject);
  private
    { Private declarations }
  public
    spojInfo:TSpojInfo;
    procedure Proved(info: TSpojInfo);
    function UdelejURL: string;
    procedure NaplnVrch;
    procedure UkazSpojeni(id: integer);
    { Public declarations }
  end;

var
  frmVysledky: TfrmVysledky;

implementation

uses
  uHlavni;

{$R *.dfm}

//******************************************************************************
//******************************************************************************
function URLencode(s:string):string;//tak na tohle testovaci server dojede a jaksi to nezpracuje
var
  i:integer;
begin
  result:='';
  for i:=1 to length(s) do
    if s[i]=' ' then
      result:=result+'+'
    else
      result:=result+s[i];
    {if s[i] in ['a'..'z','A'..'Z','-','0'..'9'] then
      result:=result+s[i]
    else
      result:=result+'%'+format('%.2x',[byte(s[i])]);}
end;

//******************************************************************************
//******************************************************************************
procedure TfrmVysledky.Proved(info: TSpojInfo);
var
  pocet,i:integer;

begin
  spojInfo:=info;
  NaplnVrch;
  try
    XMLparser.XML.text:=HTTP.Get(UdelejURL);
    XMLparser.Active:=true;

    pocet:=XMLparser.ChildNodes.FindNode('Spojeni').ChildNodes.Count;
    if pocet=0 then begin
      messageBox(handle,'Takovmuto zadn parametr neodpovd dn spojen',[],mb_iconwarning);
      close;
      exit;
    end else
      lblSpojeni2.Caption:=inttostr(pocet);

    with cbxSpoj.Items do begin
      for i:=0 to pocet-1 do
        Add('Spojen '+inttostr(i+1));
    end;
    cbxSpoj.ItemIndex:=0;
    cbxSpojChange(cbxSpoj);

  except
    
  end;
end;

//******************************************************************************
//******************************************************************************
procedure TfrmVysledky.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  action:=caFree;
end;

//******************************************************************************
//******************************************************************************
function TfrmVysledky.UdelejURL: string;
begin
  result:='http://'+frmHlavni.pripServer+'/NajdiSpojeni?';
  result:=result+'odkud='+urlencode(frmHlavni.seznamStanic[spojinfo.Odkud])+'&';
  result:=result+'kam='+urlencode(frmHlavni.seznamStanic[spojinfo.Kam])+'&';
  if spojinfo.pres<>-1 then
    result:=result+'pres='+urlencode(frmHlavni.seznamStanic[spojinfo.Pres])+'&';
  result:=result+'odjezd='+urlencode(FormatDateTime('hhnn',spojinfo.odjezd))+'&';
  if spojinfo.prestupy<>0 then
    result:=result+'prestupy='+urlencode(inttostr(spojinfo.prestupy))+'&';
  result:=result+'spojeni='+urlencode(inttostr(spojinfo.spojeni));
end;

//******************************************************************************
//******************************************************************************
procedure TfrmVysledky.NaplnVrch;
begin
  lblOdkud2.Caption:=frmHlavni.seznamStanic[spojinfo.odkud];
  lblKam2.Caption:=frmHlavni.seznamStanic[spojinfo.kam];
  if spojInfo.pres<>-1 then
    lblPres2.Caption:=frmHlavni.seznamStanic[spojinfo.pres]
  else begin
    lblPres1.Visible:=false;
    lblPres2.Visible:=false;
  end;
  lblOdjezd2.Caption:=FormatDateTime('hh:nn',spojinfo.odjezd);
  if spojinfo.prestupy=0 then
    lblPrestupy2.Caption:='Pm spoj'
  else
    lblPrestupy2.Caption:=inttostr(spojinfo.prestupy);
  lblSpojeni2.Caption:=inttostr(spojinfo.spojeni);
end;

//******************************************************************************
//******************************************************************************
procedure TfrmVysledky.UkazSpojeni(id: integer);
var
  spoj:IXMLNode;
  i:integer;

  procedure subZpracujLinku(linka:IXMLnode;s:TStrings);
  var
    i:integer;
    poznamka:TStringList;
    node,node2:IXMLNode;
    str:string;
  begin
    s.Add('Linka '+linka.GetAttribute('cislo'));
    s.Add('========================================');
    poznamka:=TStringList.Create;
    s.add(#9'Pj.'#9'Odj.'#9'Stanice');
    s.add(#9'-----'#9'----'#9'-------');
    for i:=0 to linka.ChildNodes.count-1 do begin
      node:=linka.ChildNodes.Get(i);
      if node.NodeName='Poznamka' then
        poznamka.Add(#9+node.NodeValue)
      else if node.NodeName='Stanice' then begin
        str:=#9;

        node2:=node.GetAttributeNodes.FindNode('prijezd');
        if assigned(node2) then
          str:=str+node2.NodeValue;
        str:=str+#9;

        node2:=node.GetAttributeNodes.FindNode('odjezd');
        if assigned(node2) then
          str:=str+node2.NodeValue;
        str:=str+#9;

        str:=str+node.NodeValue;
        s.add(str);
      end;
    end;
    if poznamka.Count<>0 then begin
      s.Add('');
      s.Add('Poznmka:');
      s.AddStrings(poznamka);
    end;
    poznamka.Free;
    s.Add('');
    s.Add('');
  end;

begin
  if (id>=XMLparser.ChildNodes.FindNode('Spojeni').ChildNodes.Count)or(id<0) then begin
    MessageBox(handle,'Takovto spojen nen v seznamu',mb_iconwarning);
    exit;
  end;
  spoj:=XMLparser.ChildNodes.FindNode('Spojeni').ChildNodes.Get(id);

  with memSpojeni.Lines do begin
    BeginUpdate;
    Clear;
    lblPrestupy2.Caption:=IntToStr(spoj.ChildNodes.Count);
    for i:=0 to spoj.ChildNodes.Count-1 do begin
      subZpracujLinku(spoj.ChildNodes.Get(i),memSpojeni.Lines);
    end;

    EndUpdate;
  end;
end;

//******************************************************************************
//******************************************************************************
procedure TfrmVysledky.cbxSpojChange(Sender: TObject);
begin
  UkazSpojeni(cbxSpoj.ItemIndex);
end;

end.
